Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/test.cpp
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/test.cpp	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/SelfTest/src/test.cpp	(revision 88)
@@ -814,31 +840,29 @@
 	  
 	  LABEL("exception (begin)");
-	  in_NB_INST_DECOD_ALL  [decod_unit]->write(1);
-	  in_NB_INST_COMMIT_ALL [ooo_engine]->write(1);
-	  in_NB_INST_COMMIT_MEM [ooo_engine]->write(1);
-	  
-	  uint32_t port = rand()%_param->_nb_ooo_engine;
-	  
-	  in_COMMIT_EVENT_CONTEXT_ID       [port]->write(context);
-	  if (_param->_have_port_depth [context])
-	  in_COMMIT_EVENT_DEPTH            [port]->write((context)%_param->_size_depth[context]);
-	  in_COMMIT_EVENT_TYPE             [port]->write(EVENT_TYPE_EXCEPTION);
-	  in_COMMIT_EVENT_IS_DELAY_SLOT    [port]->write(0);
-	  in_COMMIT_EVENT_ADDRESS          [port]->write(0xa00);
-	  in_COMMIT_EVENT_ADDRESS_EPCR     [port]->write(0xb00);
-	  in_COMMIT_EVENT_ADDRESS_EEAR     [port]->write(0xc00);
-	  in_COMMIT_EVENT_ADDRESS_EEAR_VAL [port]->write(0);
-
-	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
-	  
-	  do
-	    {
-	      in_COMMIT_EVENT_VAL [port]->write(rand()%percent_transaction_commit_event);
-	      
-	      SC_START(1);
-	    }
-	  while (not ( in_COMMIT_EVENT_VAL [port]->read() and
-		       out_COMMIT_EVENT_ACK [port]->read()));
-	  in_COMMIT_EVENT_VAL [port]->write(0);
+	  in_NB_INST_DECOD_ALL  [context]->write(1);
+	  in_NB_INST_COMMIT_ALL [context]->write(1);
+	  in_NB_INST_COMMIT_MEM [context]->write(1);
+	  
+	  in_COMMIT_EVENT_CONTEXT_ID       ->write(context);
+	  if (_param->_have_port_depth)
+	  in_COMMIT_EVENT_DEPTH            ->write((_param->_array_size_depth[context]==0)?0:((context)%_param->_array_size_depth[context]));
+	  in_COMMIT_EVENT_TYPE             ->write(EVENT_TYPE_EXCEPTION);
+	  in_COMMIT_EVENT_IS_DELAY_SLOT    ->write(0);
+	  in_COMMIT_EVENT_ADDRESS          ->write(0xa00);
+	  in_COMMIT_EVENT_ADDRESS_EPCR     ->write(0xb00);
+	  in_COMMIT_EVENT_ADDRESS_EEAR     ->write(0xc00);
+	  in_COMMIT_EVENT_ADDRESS_EEAR_VAL ->write(0);
+
+	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
+	  
+	  do
+	    {
+	      in_COMMIT_EVENT_VAL ->write(rand()%percent_transaction_commit_event);
+	      
+	      SC_START(1);
+	    }
+	  while (not ( in_COMMIT_EVENT_VAL ->read() and
+		       out_COMMIT_EVENT_ACK ->read()));
+	  in_COMMIT_EVENT_VAL ->write(0);
 	  
 	  LABEL("exception (wait end)");
@@ -847,7 +871,7 @@
 	  SC_START(3);
 	  
-	  in_NB_INST_DECOD_ALL  [decod_unit]->write(0);
-	  in_NB_INST_COMMIT_ALL [ooo_engine]->write(0);
-	  in_NB_INST_COMMIT_MEM [ooo_engine]->write(0);
+	  in_NB_INST_DECOD_ALL  [context]->write(0);
+	  in_NB_INST_COMMIT_ALL [context]->write(0);
+	  in_NB_INST_COMMIT_MEM [context]->write(0);
 	  
 	  SC_START(1);
@@ -883,24 +907,24 @@
 	  do
 	    {
-	      in_SPR_ACK [context]->write(rand()%percent_transaction_spr);
-	  
-	      SC_START(0);
-	  
-	      if (out_SPR_VAL [context]->read() and in_SPR_ACK [context]->read())
-	        {
-		  TEST(Taddress_t,out_SPR_EPCR      [context]->read(),0xb00);
-		  TEST(Taddress_t,out_SPR_EEAR      [context]->read(),0xc00);
-		  TEST(Tcontrol_t,out_SPR_EEAR_WEN  [context]->read(),0);
-		  TEST(Tcontrol_t,out_SPR_SR_DSX    [context]->read(),0);
-		  TEST(Tcontrol_t,out_SPR_SR_TO_ESR [context]->read(),1);
-		  
-		  find = true;
-	        }
-	      
-	      SC_START(1);
-	    }
-	  while (not find);
-
-	  in_SPR_ACK [context]->write(0);
+	      in_SPR_EVENT_ACK [context]->write(rand()%percent_transaction_spr);
+	  
+	      SC_START(0);
+	  
+	      if (out_SPR_EVENT_VAL [context]->read() and in_SPR_EVENT_ACK [context]->read())
+	        {
+		  TEST(Taddress_t,out_SPR_EVENT_EPCR      [context]->read(),0xb00);
+		  TEST(Taddress_t,out_SPR_EVENT_EEAR      [context]->read(),0xc00);
+		  TEST(Tcontrol_t,out_SPR_EVENT_EEAR_WEN  [context]->read(),0);
+		  TEST(Tcontrol_t,out_SPR_EVENT_SR_DSX    [context]->read(),0);
+		  TEST(Tcontrol_t,out_SPR_EVENT_SR_TO_ESR [context]->read(),1);
+		  
+		  find = true;
+	        }
+	      
+	      SC_START(1);
+	    }
+	  while (not find);
+
+	  in_SPR_EVENT_ACK [context]->write(0);
 	}
       
@@ -910,31 +934,29 @@
 	  
 	  LABEL("exception (begin)");
-	  in_NB_INST_DECOD_ALL  [decod_unit]->write(1);
-	  in_NB_INST_COMMIT_ALL [ooo_engine]->write(1);
-	  in_NB_INST_COMMIT_MEM [ooo_engine]->write(1);
-	  
-	  uint32_t port = rand()%_param->_nb_ooo_engine;
-	  
-	  in_COMMIT_EVENT_CONTEXT_ID       [port]->write(context);
-	  if (_param->_have_port_depth [context])
-	  in_COMMIT_EVENT_DEPTH            [port]->write((context)%_param->_size_depth[context]);
-	  in_COMMIT_EVENT_TYPE             [port]->write(EVENT_TYPE_EXCEPTION);
-	  in_COMMIT_EVENT_IS_DELAY_SLOT    [port]->write(1);
-	  in_COMMIT_EVENT_ADDRESS          [port]->write(0xd00);
-	  in_COMMIT_EVENT_ADDRESS_EPCR     [port]->write(0xe00);
-	  in_COMMIT_EVENT_ADDRESS_EEAR     [port]->write(0xf00);
-	  in_COMMIT_EVENT_ADDRESS_EEAR_VAL [port]->write(0);
-
-	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
-	  
-	  do
-	    {
-	      in_COMMIT_EVENT_VAL [port]->write(rand()%percent_transaction_commit_event);
-	      
-	      SC_START(1);
-	    }
-	  while (not ( in_COMMIT_EVENT_VAL [port]->read() and
-		       out_COMMIT_EVENT_ACK [port]->read()));
-	  in_COMMIT_EVENT_VAL [port]->write(0);
+	  in_NB_INST_DECOD_ALL  [context]->write(1);
+	  in_NB_INST_COMMIT_ALL [context]->write(1);
+	  in_NB_INST_COMMIT_MEM [context]->write(1);
+	  
+	  in_COMMIT_EVENT_CONTEXT_ID       ->write(context);
+	  if (_param->_have_port_depth)
+	  in_COMMIT_EVENT_DEPTH            ->write((_param->_array_size_depth[context]==0)?0:((context)%_param->_array_size_depth[context]));
+	  in_COMMIT_EVENT_TYPE             ->write(EVENT_TYPE_EXCEPTION);
+	  in_COMMIT_EVENT_IS_DELAY_SLOT    ->write(1);
+	  in_COMMIT_EVENT_ADDRESS          ->write(0xd00);
+	  in_COMMIT_EVENT_ADDRESS_EPCR     ->write(0xe00);
+	  in_COMMIT_EVENT_ADDRESS_EEAR     ->write(0xf00);
+	  in_COMMIT_EVENT_ADDRESS_EEAR_VAL ->write(0);
+
+	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
+	  
+	  do
+	    {
+	      in_COMMIT_EVENT_VAL ->write(rand()%percent_transaction_commit_event);
+	      
+	      SC_START(1);
+	    }
+	  while (not ( in_COMMIT_EVENT_VAL ->read() and
+		       out_COMMIT_EVENT_ACK ->read()));
+	  in_COMMIT_EVENT_VAL ->write(0);
 	  
 	  LABEL("exception (wait end)");
@@ -943,7 +965,7 @@
 	  SC_START(3);
 	  
-	  in_NB_INST_DECOD_ALL  [decod_unit]->write(0);
-	  in_NB_INST_COMMIT_ALL [ooo_engine]->write(0);
-	  in_NB_INST_COMMIT_MEM [ooo_engine]->write(0);
+	  in_NB_INST_DECOD_ALL  [context]->write(0);
+	  in_NB_INST_COMMIT_ALL [context]->write(0);
+	  in_NB_INST_COMMIT_MEM [context]->write(0);
 	  
 	  SC_START(1);
@@ -979,24 +1001,24 @@
 	  do
 	    {
-	      in_SPR_ACK [context]->write(rand()%percent_transaction_spr);
-	  
-	      SC_START(0);
-	  
-	      if (out_SPR_VAL [context]->read() and in_SPR_ACK [context]->read())
-	        {
-		  TEST(Taddress_t,out_SPR_EPCR      [context]->read(),0xe00);
-		  TEST(Taddress_t,out_SPR_EEAR      [context]->read(),0xf00);
-		  TEST(Tcontrol_t,out_SPR_EEAR_WEN  [context]->read(),0);
-		  TEST(Tcontrol_t,out_SPR_SR_DSX    [context]->read(),1);
-		  TEST(Tcontrol_t,out_SPR_SR_TO_ESR [context]->read(),1);
-		  
-		  find = true;
-	        }
-	      
-	      SC_START(1);
-	    }
-	  while (not find);
-
-	  in_SPR_ACK [context]->write(0);
+	      in_SPR_EVENT_ACK [context]->write(rand()%percent_transaction_spr);
+	  
+	      SC_START(0);
+	  
+	      if (out_SPR_EVENT_VAL [context]->read() and in_SPR_EVENT_ACK [context]->read())
+	        {
+		  TEST(Taddress_t,out_SPR_EVENT_EPCR      [context]->read(),0xe00);
+		  TEST(Taddress_t,out_SPR_EVENT_EEAR      [context]->read(),0xf00);
+		  TEST(Tcontrol_t,out_SPR_EVENT_EEAR_WEN  [context]->read(),0);
+		  TEST(Tcontrol_t,out_SPR_EVENT_SR_DSX    [context]->read(),1);
+		  TEST(Tcontrol_t,out_SPR_EVENT_SR_TO_ESR [context]->read(),1);
+		  
+		  find = true;
+	        }
+	      
+	      SC_START(1);
+	    }
+	  while (not find);
+
+	  in_SPR_EVENT_ACK [context]->write(0);
 	}
 
@@ -1006,31 +1028,29 @@
 	  
 	  LABEL("exception (begin)");
-	  in_NB_INST_DECOD_ALL  [decod_unit]->write(1);
-	  in_NB_INST_COMMIT_ALL [ooo_engine]->write(1);
-	  in_NB_INST_COMMIT_MEM [ooo_engine]->write(1);
-	  
-	  uint32_t port = rand()%_param->_nb_ooo_engine;
-	  
-	  in_COMMIT_EVENT_CONTEXT_ID       [port]->write(context);
-	  if (_param->_have_port_depth [context])
-	  in_COMMIT_EVENT_DEPTH            [port]->write((context)%_param->_size_depth[context]);
-	  in_COMMIT_EVENT_TYPE             [port]->write(EVENT_TYPE_EXCEPTION);
-	  in_COMMIT_EVENT_IS_DELAY_SLOT    [port]->write(0);
-	  in_COMMIT_EVENT_ADDRESS          [port]->write(0xa00);
-	  in_COMMIT_EVENT_ADDRESS_EPCR     [port]->write(0xb00);
-	  in_COMMIT_EVENT_ADDRESS_EEAR     [port]->write(0xc00);
-	  in_COMMIT_EVENT_ADDRESS_EEAR_VAL [port]->write(1);
-
-	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
-	  
-	  do
-	    {
-	      in_COMMIT_EVENT_VAL [port]->write(rand()%percent_transaction_commit_event);
-	      
-	      SC_START(1);
-	    }
-	  while (not ( in_COMMIT_EVENT_VAL [port]->read() and
-		       out_COMMIT_EVENT_ACK [port]->read()));
-	  in_COMMIT_EVENT_VAL [port]->write(0);
+	  in_NB_INST_DECOD_ALL  [context]->write(1);
+	  in_NB_INST_COMMIT_ALL [context]->write(1);
+	  in_NB_INST_COMMIT_MEM [context]->write(1);
+	  
+	  in_COMMIT_EVENT_CONTEXT_ID       ->write(context);
+	  if (_param->_have_port_depth)
+	  in_COMMIT_EVENT_DEPTH            ->write((_param->_array_size_depth[context]==0)?0:((context)%_param->_array_size_depth[context]));
+	  in_COMMIT_EVENT_TYPE             ->write(EVENT_TYPE_EXCEPTION);
+	  in_COMMIT_EVENT_IS_DELAY_SLOT    ->write(0);
+	  in_COMMIT_EVENT_ADDRESS          ->write(0xa00);
+	  in_COMMIT_EVENT_ADDRESS_EPCR     ->write(0xb00);
+	  in_COMMIT_EVENT_ADDRESS_EEAR     ->write(0xc00);
+	  in_COMMIT_EVENT_ADDRESS_EEAR_VAL ->write(1);
+
+	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
+	  
+	  do
+	    {
+	      in_COMMIT_EVENT_VAL ->write(rand()%percent_transaction_commit_event);
+	      
+	      SC_START(1);
+	    }
+	  while (not ( in_COMMIT_EVENT_VAL ->read() and
+		       out_COMMIT_EVENT_ACK ->read()));
+	  in_COMMIT_EVENT_VAL ->write(0);
 	  
 	  LABEL("exception (wait end)");
@@ -1039,7 +1059,7 @@
 	  SC_START(3);
 	  
-	  in_NB_INST_DECOD_ALL  [decod_unit]->write(0);
-	  in_NB_INST_COMMIT_ALL [ooo_engine]->write(0);
-	  in_NB_INST_COMMIT_MEM [ooo_engine]->write(0);
+	  in_NB_INST_DECOD_ALL  [context]->write(0);
+	  in_NB_INST_COMMIT_ALL [context]->write(0);
+	  in_NB_INST_COMMIT_MEM [context]->write(0);
 	  
 	  SC_START(1);
@@ -1075,24 +1095,24 @@
 	  do
 	    {
-	      in_SPR_ACK [context]->write(rand()%percent_transaction_spr);
-	  
-	      SC_START(0);
-	  
-	      if (out_SPR_VAL [context]->read() and in_SPR_ACK [context]->read())
-	        {
-		  TEST(Taddress_t,out_SPR_EPCR      [context]->read(),0xb00);
-		  TEST(Taddress_t,out_SPR_EEAR      [context]->read(),0xc00);
-		  TEST(Tcontrol_t,out_SPR_EEAR_WEN  [context]->read(),1);
-		  TEST(Tcontrol_t,out_SPR_SR_DSX    [context]->read(),0);
-		  TEST(Tcontrol_t,out_SPR_SR_TO_ESR [context]->read(),1);
-		  
-		  find = true;
-	        }
-	      
-	      SC_START(1);
-	    }
-	  while (not find);
-
-	  in_SPR_ACK [context]->write(0);
+	      in_SPR_EVENT_ACK [context]->write(rand()%percent_transaction_spr);
+	  
+	      SC_START(0);
+	  
+	      if (out_SPR_EVENT_VAL [context]->read() and in_SPR_EVENT_ACK [context]->read())
+	        {
+		  TEST(Taddress_t,out_SPR_EVENT_EPCR      [context]->read(),0xb00);
+		  TEST(Taddress_t,out_SPR_EVENT_EEAR      [context]->read(),0xc00);
+		  TEST(Tcontrol_t,out_SPR_EVENT_EEAR_WEN  [context]->read(),1);
+		  TEST(Tcontrol_t,out_SPR_EVENT_SR_DSX    [context]->read(),0);
+		  TEST(Tcontrol_t,out_SPR_EVENT_SR_TO_ESR [context]->read(),1);
+		  
+		  find = true;
+	        }
+	      
+	      SC_START(1);
+	    }
+	  while (not find);
+
+	  in_SPR_EVENT_ACK [context]->write(0);
 	}
       
@@ -1102,31 +1122,29 @@
 	  
 	  LABEL("exception (begin)");
-	  in_NB_INST_DECOD_ALL  [decod_unit]->write(1);
-	  in_NB_INST_COMMIT_ALL [ooo_engine]->write(1);
-	  in_NB_INST_COMMIT_MEM [ooo_engine]->write(1);
-	  
-	  uint32_t port = rand()%_param->_nb_ooo_engine;
-	  
-	  in_COMMIT_EVENT_CONTEXT_ID       [port]->write(context);
-	  if (_param->_have_port_depth [context])
-	  in_COMMIT_EVENT_DEPTH            [port]->write((context)%_param->_size_depth[context]);
-	  in_COMMIT_EVENT_TYPE             [port]->write(EVENT_TYPE_EXCEPTION);
-	  in_COMMIT_EVENT_IS_DELAY_SLOT    [port]->write(1);
-	  in_COMMIT_EVENT_ADDRESS          [port]->write(0xd00);
-	  in_COMMIT_EVENT_ADDRESS_EPCR     [port]->write(0xe00);
-	  in_COMMIT_EVENT_ADDRESS_EEAR     [port]->write(0xf00);
-	  in_COMMIT_EVENT_ADDRESS_EEAR_VAL [port]->write(1);
-
-	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
-	  
-	  do
-	    {
-	      in_COMMIT_EVENT_VAL [port]->write(rand()%percent_transaction_commit_event);
-	      
-	      SC_START(1);
-	    }
-	  while (not ( in_COMMIT_EVENT_VAL [port]->read() and
-		       out_COMMIT_EVENT_ACK [port]->read()));
-	  in_COMMIT_EVENT_VAL [port]->write(0);
+	  in_NB_INST_DECOD_ALL  [context]->write(1);
+	  in_NB_INST_COMMIT_ALL [context]->write(1);
+	  in_NB_INST_COMMIT_MEM [context]->write(1);
+	  
+	  in_COMMIT_EVENT_CONTEXT_ID       ->write(context);
+	  if (_param->_have_port_depth)
+	  in_COMMIT_EVENT_DEPTH            ->write((_param->_array_size_depth[context]==0)?0:((context)%_param->_array_size_depth[context]));
+	  in_COMMIT_EVENT_TYPE             ->write(EVENT_TYPE_EXCEPTION);
+	  in_COMMIT_EVENT_IS_DELAY_SLOT    ->write(1);
+	  in_COMMIT_EVENT_ADDRESS          ->write(0xd00);
+	  in_COMMIT_EVENT_ADDRESS_EPCR     ->write(0xe00);
+	  in_COMMIT_EVENT_ADDRESS_EEAR     ->write(0xf00);
+	  in_COMMIT_EVENT_ADDRESS_EEAR_VAL ->write(1);
+
+	  TEST(Tcontrol_t, out_CONTEXT_DECOD_ENABLE[context]->read(), 1);
+	  
+	  do
+	    {
+	      in_COMMIT_EVENT_VAL ->write(rand()%percent_transaction_commit_event);
+	      
+	      SC_START(1);
+	    }
+	  while (not ( in_COMMIT_EVENT_VAL ->read() and
+		       out_COMMIT_EVENT_ACK ->read()));
+	  in_COMMIT_EVENT_VAL ->write(0);
 	  
 	  LABEL("exception (wait end)");
@@ -1135,7 +1153,7 @@
 	  SC_START(3);
 	  
-	  in_NB_INST_DECOD_ALL  [decod_unit]->write(0);
-	  in_NB_INST_COMMIT_ALL [ooo_engine]->write(0);
-	  in_NB_INST_COMMIT_MEM [ooo_engine]->write(0);
+	  in_NB_INST_DECOD_ALL  [context]->write(0);
+	  in_NB_INST_COMMIT_ALL [context]->write(0);
+	  in_NB_INST_COMMIT_MEM [context]->write(0);
 	  
 	  SC_START(1);
@@ -1171,24 +1189,24 @@
 	  do
 	    {
-	      in_SPR_ACK [context]->write(rand()%percent_transaction_spr);
-	  
-	      SC_START(0);
-	  
-	      if (out_SPR_VAL [context]->read() and in_SPR_ACK [context]->read())
-	        {
-		  TEST(Taddress_t,out_SPR_EPCR      [context]->read(),0xe00);
-		  TEST(Taddress_t,out_SPR_EEAR      [context]->read(),0xf00);
-		  TEST(Tcontrol_t,out_SPR_EEAR_WEN  [context]->read(),1);
-		  TEST(Tcontrol_t,out_SPR_SR_DSX    [context]->read(),1);
-		  TEST(Tcontrol_t,out_SPR_SR_TO_ESR [context]->read(),1);
-		  
-		  find = true;
-	        }
-	      
-	      SC_START(1);
-	    }
-	  while (not find);
-
-	  in_SPR_ACK [context]->write(0);
+	      in_SPR_EVENT_ACK [context]->write(rand()%percent_transaction_spr);
+	  
+	      SC_START(0);
+	  
+	      if (out_SPR_EVENT_VAL [context]->read() and in_SPR_EVENT_ACK [context]->read())
+	        {
+		  TEST(Taddress_t,out_SPR_EVENT_EPCR      [context]->read(),0xe00);
+		  TEST(Taddress_t,out_SPR_EVENT_EEAR      [context]->read(),0xf00);
+		  TEST(Tcontrol_t,out_SPR_EVENT_EEAR_WEN  [context]->read(),1);
+		  TEST(Tcontrol_t,out_SPR_EVENT_SR_DSX    [context]->read(),1);
+		  TEST(Tcontrol_t,out_SPR_EVENT_SR_TO_ESR [context]->read(),1);
+		  
+		  find = true;
+	        }
+	      
+	      SC_START(1);
+	    }
+	  while (not find);
+
+	  in_SPR_EVENT_ACK [context]->write(0);
 	}
 
@@ -1210,4 +1228,11 @@
   delete in_NRESET;
 
+  DELETE1_SC_SIGNAL( in_BRANCH_EVENT_VAL               ,_param->_nb_context);
+  DELETE1_SC_SIGNAL(out_BRANCH_EVENT_ACK               ,_param->_nb_context);
+//DELETE1_SC_SIGNAL( in_BRANCH_EVENT_CONTEXT_ID        ,_param->_nb_context);
+//DELETE1_SC_SIGNAL( in_BRANCH_EVENT_DEPTH             ,_param->_nb_context);
+//DELETE1_SC_SIGNAL( in_BRANCH_EVENT_MISS_PREDICTION   ,_param->_nb_context);
+  DELETE1_SC_SIGNAL( in_BRANCH_EVENT_ADDRESS_SRC       ,_param->_nb_context);
+  DELETE1_SC_SIGNAL( in_BRANCH_EVENT_ADDRESS_DEST      ,_param->_nb_context);
   DELETE1_SC_SIGNAL( in_DECOD_EVENT_VAL                ,_param->_nb_decod_unit);
   DELETE1_SC_SIGNAL(out_DECOD_EVENT_ACK                ,_param->_nb_decod_unit);
@@ -1218,14 +1243,14 @@
   DELETE1_SC_SIGNAL( in_DECOD_EVENT_ADDRESS            ,_param->_nb_decod_unit);
   DELETE1_SC_SIGNAL( in_DECOD_EVENT_ADDRESS_EPCR       ,_param->_nb_decod_unit);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_VAL               ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL(out_COMMIT_EVENT_ACK               ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_CONTEXT_ID        ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_DEPTH             ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_TYPE              ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_IS_DELAY_SLOT     ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_ADDRESS           ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_ADDRESS_EPCR      ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_ADDRESS_EEAR_VAL  ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_COMMIT_EVENT_ADDRESS_EEAR      ,_param->_nb_ooo_engine);
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_VAL               );
+  DELETE_SC_SIGNAL (out_COMMIT_EVENT_ACK               );
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_CONTEXT_ID        );
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_DEPTH             );
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_TYPE              );
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_IS_DELAY_SLOT     );
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_ADDRESS           );
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_ADDRESS_EPCR      );
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_ADDRESS_EEAR_VAL  );
+  DELETE_SC_SIGNAL ( in_COMMIT_EVENT_ADDRESS_EEAR      );
   DELETE1_SC_SIGNAL( in_BRANCH_COMPLETE_VAL            ,_param->_nb_inst_branch_complete);
   DELETE1_SC_SIGNAL(out_BRANCH_COMPLETE_ACK            ,_param->_nb_inst_branch_complete);
@@ -1236,7 +1261,7 @@
   DELETE1_SC_SIGNAL( in_BRANCH_COMPLETE_ADDRESS_SRC    ,_param->_nb_inst_branch_complete);
   DELETE1_SC_SIGNAL( in_BRANCH_COMPLETE_ADDRESS_DEST   ,_param->_nb_inst_branch_complete);
-  DELETE1_SC_SIGNAL( in_NB_INST_DECOD_ALL              ,_param->_nb_decod_unit);
-  DELETE1_SC_SIGNAL( in_NB_INST_COMMIT_ALL             ,_param->_nb_ooo_engine);
-  DELETE1_SC_SIGNAL( in_NB_INST_COMMIT_MEM             ,_param->_nb_ooo_engine);
+  DELETE1_SC_SIGNAL( in_NB_INST_DECOD_ALL              ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL( in_NB_INST_COMMIT_ALL             ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL( in_NB_INST_COMMIT_MEM             ,_param->_nb_context   );
   DELETE1_SC_SIGNAL(out_EVENT_VAL                      ,_param->_nb_context   );
   DELETE1_SC_SIGNAL( in_EVENT_ACK                      ,_param->_nb_context   );
@@ -1245,13 +1270,17 @@
   DELETE1_SC_SIGNAL(out_EVENT_ADDRESS_NEXT_VAL         ,_param->_nb_context   );
   DELETE1_SC_SIGNAL(out_EVENT_IS_DS_TAKE               ,_param->_nb_context   );
-  DELETE1_SC_SIGNAL(out_SPR_VAL                        ,_param->_nb_context   );
-  DELETE1_SC_SIGNAL( in_SPR_ACK                        ,_param->_nb_context   );
-  DELETE1_SC_SIGNAL(out_SPR_EPCR                       ,_param->_nb_context   );
-  DELETE1_SC_SIGNAL(out_SPR_EEAR                       ,_param->_nb_context   );
-  DELETE1_SC_SIGNAL(out_SPR_EEAR_WEN                   ,_param->_nb_context   );
-  DELETE1_SC_SIGNAL(out_SPR_SR_DSX                     ,_param->_nb_context   );
-  DELETE1_SC_SIGNAL(out_SPR_SR_TO_ESR                  ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL(out_SPR_EVENT_VAL                  ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL( in_SPR_EVENT_ACK                  ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL(out_SPR_EVENT_EPCR                 ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL(out_SPR_EVENT_EEAR                 ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL(out_SPR_EVENT_EEAR_WEN             ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL(out_SPR_EVENT_SR_DSX               ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL(out_SPR_EVENT_SR_TO_ESR            ,_param->_nb_context   );
   DELETE1_SC_SIGNAL(out_CONTEXT_DECOD_ENABLE           ,_param->_nb_context   );
-  DELETE1_SC_SIGNAL( in_DEPTH_TAIL                     ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL( in_DEPTH_MIN                      ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL( in_SPR_SR_IEE                     ,_param->_nb_context   );
+  DELETE1_SC_SIGNAL( in_SPR_SR_EPH                     ,_param->_nb_context   );
+
+  DELETE1_SC_SIGNAL( in_INTERRUPT_ENABLE               ,_param->_nb_context   );
     }
 #endif
Index: /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h
===================================================================
--- /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h	(revision 87)
+++ /trunk/IPs/systemC/processor/Morpheo/Behavioural/Core/Multi_Front_end/Front_end/Context_State/include/Context_State.h	(revision 88)
@@ -62,4 +62,13 @@
   public    : SC_CLOCK                      *  in_CLOCK        ;
   public    : SC_IN (Tcontrol_t)            *  in_NRESET       ;
+
+    // ~~~~~[ Interface : "branch_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t         )  **  in_BRANCH_EVENT_VAL                   ;//[nb_context]
+  public    : SC_OUT(Tcontrol_t         )  ** out_BRANCH_EVENT_ACK                   ;//[nb_context]
+//public    : SC_IN (Tcontext_t         )  **  in_BRANCH_EVENT_CONTEXT_ID            ;//[nb_context]
+//public    : SC_IN (Tdepth_t           )  **  in_BRANCH_EVENT_DEPTH                 ;//[nb_context]
+//public    : SC_IN (Tcontrol_t         )  **  in_BRANCH_EVENT_MISS_PREDICTION       ;//[nb_context]
+  public    : SC_IN (Taddress_t         )  **  in_BRANCH_EVENT_ADDRESS_SRC           ;//[nb_context]
+  public    : SC_IN (Taddress_t         )  **  in_BRANCH_EVENT_ADDRESS_DEST          ;//[nb_context]
 
     // ~~~~~[ Interface : "decod_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -74,14 +83,14 @@
 
     // ~~~~~[ Interface : "commit_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tcontrol_t         )  **  in_COMMIT_EVENT_VAL                   ;//[nb_ooo_engine]
-  public    : SC_OUT(Tcontrol_t         )  ** out_COMMIT_EVENT_ACK                   ;//[nb_ooo_engine]
-  public    : SC_IN (Tcontext_t         )  **  in_COMMIT_EVENT_CONTEXT_ID            ;//[nb_ooo_engine]
-  public    : SC_IN (Tdepth_t           )  **  in_COMMIT_EVENT_DEPTH                 ;//[nb_ooo_engine]
-  public    : SC_IN (Tevent_type_t      )  **  in_COMMIT_EVENT_TYPE                  ;//[nb_ooo_engine]
-  public    : SC_IN (Tcontrol_t         )  **  in_COMMIT_EVENT_IS_DELAY_SLOT         ;//[nb_ooo_engine]
-  public    : SC_IN (Taddress_t         )  **  in_COMMIT_EVENT_ADDRESS               ;//[nb_ooo_engine]
-  public    : SC_IN (Taddress_t         )  **  in_COMMIT_EVENT_ADDRESS_EPCR          ;//[nb_ooo_engine]
-  public    : SC_IN (Tcontrol_t         )  **  in_COMMIT_EVENT_ADDRESS_EEAR_VAL      ;//[nb_ooo_engine]
-  public    : SC_IN (Taddress_t         )  **  in_COMMIT_EVENT_ADDRESS_EEAR          ;//[nb_ooo_engine]
+  public    : SC_IN (Tcontrol_t         )   *  in_COMMIT_EVENT_VAL                   ;
+  public    : SC_OUT(Tcontrol_t         )   * out_COMMIT_EVENT_ACK                   ;
+  public    : SC_IN (Tcontext_t         )   *  in_COMMIT_EVENT_CONTEXT_ID            ;
+  public    : SC_IN (Tdepth_t           )   *  in_COMMIT_EVENT_DEPTH                 ;
+  public    : SC_IN (Tevent_type_t      )   *  in_COMMIT_EVENT_TYPE                  ;
+  public    : SC_IN (Tcontrol_t         )   *  in_COMMIT_EVENT_IS_DELAY_SLOT         ;
+  public    : SC_IN (Taddress_t         )   *  in_COMMIT_EVENT_ADDRESS               ;
+  public    : SC_IN (Taddress_t         )   *  in_COMMIT_EVENT_ADDRESS_EPCR          ;
+  public    : SC_IN (Tcontrol_t         )   *  in_COMMIT_EVENT_ADDRESS_EEAR_VAL      ;
+  public    : SC_IN (Taddress_t         )   *  in_COMMIT_EVENT_ADDRESS_EEAR          ;
 
     // ~~~~~[ Interface : "branch_complete" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -96,7 +105,7 @@
 
     // ~~~~~[ Interface : "nb_inst" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tcounter_t         )  **  in_NB_INST_DECOD_ALL                  ;//[nb_decod_unit]
-  public    : SC_IN (Tcounter_t         )  **  in_NB_INST_COMMIT_ALL                 ;//[nb_ooo_engine]
-  public    : SC_IN (Tcounter_t         )  **  in_NB_INST_COMMIT_MEM                 ;//[nb_ooo_engine]
+  public    : SC_IN (Tcounter_t         )  **  in_NB_INST_DECOD_ALL                  ;//[nb_context]
+  public    : SC_IN (Tcounter_t         )  **  in_NB_INST_COMMIT_ALL                 ;//[nb_context]
+  public    : SC_IN (Tcounter_t         )  **  in_NB_INST_COMMIT_MEM                 ;//[nb_context]
 
     // ~~~~~[ Interface "event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -108,12 +117,12 @@
   public    : SC_OUT(Tcontrol_t         )  ** out_EVENT_IS_DS_TAKE                   ;//[nb_context]
 
-    // ~~~~~[ Interface "spr" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_OUT(Tcontrol_t         )  ** out_SPR_VAL                            ;//[nb_context]
-  public    : SC_IN (Tcontrol_t         )  **  in_SPR_ACK                            ;//[nb_context]
-  public    : SC_OUT(Taddress_t         )  ** out_SPR_EPCR                           ;//[nb_context]
-  public    : SC_OUT(Taddress_t         )  ** out_SPR_EEAR                           ;//[nb_context]
-  public    : SC_OUT(Tcontrol_t         )  ** out_SPR_EEAR_WEN                       ;//[nb_context]
-  public    : SC_OUT(Tcontrol_t         )  ** out_SPR_SR_DSX                         ;//[nb_context]
-  public    : SC_OUT(Tcontrol_t         )  ** out_SPR_SR_TO_ESR                      ;//[nb_context]
+    // ~~~~~[ Interface "spr_event" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_OUT(Tcontrol_t         )  ** out_SPR_EVENT_VAL                      ;//[nb_context]
+  public    : SC_IN (Tcontrol_t         )  **  in_SPR_EVENT_ACK                      ;//[nb_context]
+  public    : SC_OUT(Taddress_t         )  ** out_SPR_EVENT_EPCR                     ;//[nb_context]
+  public    : SC_OUT(Taddress_t         )  ** out_SPR_EVENT_EEAR                     ;//[nb_context]
+  public    : SC_OUT(Tcontrol_t         )  ** out_SPR_EVENT_EEAR_WEN                 ;//[nb_context]
+  public    : SC_OUT(Tcontrol_t         )  ** out_SPR_EVENT_SR_DSX                   ;//[nb_context]
+  public    : SC_OUT(Tcontrol_t         )  ** out_SPR_EVENT_SR_TO_ESR                ;//[nb_context]
 
     // ~~~~~[ Interface : "context" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
@@ -121,5 +130,12 @@
 
     // ~~~~~[ Interface : "depth" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
-  public    : SC_IN (Tdepth_t           )  **  in_DEPTH_TAIL                         ;//[nb_context]
+  public    : SC_IN (Tdepth_t           )  **  in_DEPTH_MIN                          ;//[nb_context]
+
+    // ~~~~~[ Interface : "spr" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~         
+  public    : SC_IN (Tcontrol_t         )  **  in_SPR_SR_IEE                         ;//[nb_context] - Interrupt Exception Enabled
+  public    : SC_IN (Tcontrol_t         )  **  in_SPR_SR_EPH                         ;//[nb_context] - Exception Prefix High
+
+    // ~~~~~[ Interface : "interrupt" ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  public    : SC_IN (Tcontrol_t         )  **  in_INTERRUPT_ENABLE                   ;//[nb_context] - Interrupt Exception
                                                                                      
     // ~~~~~[ Component ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~    
@@ -135,11 +151,13 @@
   private   : Tcontrol_t                    * reg_EVENT_IS_DS_TAKE                   ;//[nb_context]
   private   : Tdepth_t                      * reg_EVENT_DEPTH                        ;//[nb_context]
+  private   : Tcontrol_t                    * reg_INTERRUPT_ENABLE                   ;//[nb_context]
 
     // ~~~~~[ Internal ]~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+  private   : Tcontrol_t                    * internal_BRANCH_EVENT_ACK              ;//[nb_context]
   private   : Tcontrol_t                    * internal_DECOD_EVENT_ACK               ;//[nb_decod_unit]
-  private   : Tcontrol_t                    * internal_COMMIT_EVENT_ACK              ;//[nb_ooo_engine]
+  private   : Tcontrol_t                      internal_COMMIT_EVENT_ACK              ;
   private   : Tcontrol_t                    * internal_BRANCH_COMPLETE_ACK           ;//[nb_inst_branch_complete]
   private   : Tcontrol_t                    * internal_EVENT_VAL                     ;//[nb_context]
-  private   : Tcontrol_t                    * internal_SPR_VAL                       ;//[nb_context]
+  private   : Tcontrol_t                    * internal_SPR_EVENT_VAL                 ;//[nb_context]
 #endif
 
